Package picard.illumina.parser

## Class PerTileParser<ILLUMINA_DATA extends picard.illumina.parser.IlluminaData>

- java.lang.Object
- - picard.illumina.parser.PerTileParser<ILLUMINA_DATA>

- All Implemented Interfaces:
    `Iterator<ILLUMINA_DATA>`
  Direct Known Subclasses:
    `PosParser`

      public abstract class PerTileParser<ILLUMINA_DATA extends picard.illumina.parser.IlluminaData>
      extends Object

  Abstract base class for Parsers that open a single tile file at a time and iterate through them.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PerTileParser​(picard.illumina.parser.IlluminaFileMap tilesToFiles)` |
    `PerTileParser​(picard.illumina.parser.IlluminaFileMap tilesToFiles, int nextTile)` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` |
    `int` | `getTileOfNextCluster()` | Return the tile of the NEXT ILLUMINA_DATA object to be returned by the method next.
    `boolean` | `hasNext()` |
    `protected abstract htsjdk.samtools.util.CloseableIterator<ILLUMINA_DATA>` | `makeTileIterator​(File nextTileFile)` | Factory method for the iterator of each tile
    `void` | `maybeAdvance()` |
    `ILLUMINA_DATA` | `next()` |
    `void` | `remove()` |
    `void` | `seekToTile​(int oneBasedTileNumber)` |
    `Set<IlluminaDataType>` | `supportedTypes()` | The DataTypes that this parser can provide
    `void` | `verifyData​(List<Integer> tiles, int[] cycles)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining`

- - ### Constructor Detail

    - #### PerTileParser

          public PerTileParser​(picard.illumina.parser.IlluminaFileMap tilesToFiles)

    - #### PerTileParser

          public PerTileParser​(picard.illumina.parser.IlluminaFileMap tilesToFiles,
                               int nextTile)

  - ### Method Detail

    - #### makeTileIterator

          protected abstract htsjdk.samtools.util.CloseableIterator<ILLUMINA_DATA> makeTileIterator​(File nextTileFile)

      Factory method for the iterator of each tile

    - #### getTileOfNextCluster

          public int getTileOfNextCluster()

      Return the tile of the NEXT ILLUMINA_DATA object to be returned by the method next. This might force us to advance to the next file (as it will contains the data for the next) tile/ILLUMINA_DATA object.
      Returns:
        tile number for the next ILLUMINA_DATA object to be returned

    - #### seekToTile

          public void seekToTile​(int oneBasedTileNumber)

    - #### maybeAdvance

          public void maybeAdvance()

    - #### next

          public ILLUMINA_DATA next()

      Specified by:
        `next` in interface `Iterator<ILLUMINA_DATA extends picard.illumina.parser.IlluminaData>`

    - #### remove

          public void remove()

      Specified by:
        `remove` in interface `Iterator<ILLUMINA_DATA extends picard.illumina.parser.IlluminaData>`

    - #### hasNext

          public boolean hasNext()

      Specified by:
        `hasNext` in interface `Iterator<ILLUMINA_DATA extends picard.illumina.parser.IlluminaData>`

    - #### close

          public void close()

    - #### verifyData

          public void verifyData​(List<Integer> tiles,
                                 int[] cycles)

    - #### supportedTypes

          public abstract Set<IlluminaDataType> supportedTypes()

      The DataTypes that this parser can provide